@echo off

rem ############################## iwa ##############################
rem dir c:\cap
rem if "%errorlevel%"=="0" rd /s /q c:\cap
rem ############################## iwa ##############################

rem $Id: installCAP.bat,v 1.2 2006/10/17 14:45:24 ArkadiusK Exp $
rem $Id: installCap.bat,v 1.3 2011/08/25 11:31:00 IgorK Exp $
setlocal EnableDelayedExpansion

SET SOFTNAME=MACSQuantify Software

title !SOFTNAME! installer ...

SET DISABLE_CLEANUP=1
SET INSTVER=v1.38

SET CLS=cls

echo called with arguments %*
!CLS!

rem --------------------------------------
rem check for delayed expansion
rem --------------------------------------
set DELAY_EXP=ON
if NOT !DELAY_EXP!==%DELAY_EXP% (
    @echo Delayed expansion is off! Restart with script with delayed expansion ...
    call %COMSPEC% /V /C %0 %*
    goto finish3
) else (
   @echo Delayed expansion is on!
)
!CLS!

rem --------------------------------------
rem Possible ERROR Codes
rem --------------------------------------
set ERROR_NONE=0
set ERROR_REGISTRY=1
set ERROR_OLD_CAP_ACCESS=2
set ERROR_OLD_INSTALL_CAP_ACCESS=3
set ERROR_INSTALL_PREPARE_CAP=4
set ERROR_SYSTEM_PREPARE=5
set ERROR_INSTALL_EXTRACT_CAP=6
set ERROR_COPY_MQID=7
set ERROR_COPY_CFG_FROM_CFG=8
set ERROR_COPY_CFG_FROM_GLOBAL=9
set ERROR_COPY_CFG_FROM_USER=10
set ERROR_COPY_MQD_FROM_GLOBAL=11
set ERROR_COPY_MQD_FROM_USER=12
set ERROR_COPY_FCS_FROM_GLOBAL=13
set ERROR_COPY_FCS_FROM_USER=14
set ERROR_COPY_CSV_FROM_GLOBAL=15
set ERROR_COPY_CSV_FROM_USER=16
set ERROR_COPY_USERCFG=17
set ERROR_COPY_RG_FROM_GLOBAL=18
set ERROR_COPY_RG_FROM_USER=19
set ERROR_CLEANUP_BAK=20
set ERROR_CREATE_BACKUP=21
set ERROR_CREATE_CAP=22
set ERROR_CREATE_LNK=23
set ERROR_CLEANUP_TEMP=24
set ERROR_SET_ACCESS_RIGHTS=25
set ERROR_SYSTEM_UPDATE=26
set ERROR_DELETE_FILE=27

rem State holder
set INSTALL_ERROR=!ERROR_NONE!

rem --------------------------------------
rem ---- check registry entries for old cap installation! ----
echo Check registry for !SOFTNAME! installation ...
rem --------------------------------------

set CAP=""
set DEST_NAME=""
set REG_CAP=0
set CAPPATH_LEN=0
set REQUIRE_COMMIT = 0


reg query "HKCU\Software\Miltenyi Biotec\CAP" 1> nul 2> nul
if !ERRORLEVEL! NEQ 0 (
    echo Registry not exist
    goto end_reg_check
)
set REG_CAP=1

reg add "HKCU\Software\Miltenyi Biotec\CAP" /v State /t REG_DWORD /d 1 /f 1> nul 2> nul

for /F "usebackq delims==" %%f in ( `reg query "HKCU\Software\Miltenyi Biotec\CAP" /v Path`) do (
    @for /F "tokens=1-4" %%g in ("%%f") do (
        if %%g==Path if %%h==REG_SZ call set CAP=%%i
    )
)
if NOT "%CAP%"=="" (
    set CAP_TEMP=!%CAP:\= %!
    for %%h in ( !CAP_TEMP! ) do (
        call set BINPATH=%%h
    )

    set /A BINPATH_LEN=1

    :loop
    if NOT "!BINPATH!"=="" (
        set /A BINPATH_LEN+=1
        set BINPATH=!BINPATH:~0,-1!
        goto loop
    )

    set DEST=!CAP:~0,-%BINPATH_LEN%!

    @echo DESTINATION: %DEST%

    set CAP_TEMP=!%DEST:\= %!
    for %%h in ( !CAP_TEMP! ) do (
        call set CAPPATH=%%h
    )

    set /A CAPPATH_LEN=1
    set DEST_NAME=!CAPPATH!

    :loop2
    if NOT "!CAPPATH!"=="" (
        set /A CAPPATH_LEN+=1
        set CAPPATH=!CAPPATH:~0,-1!
        goto loop2
    )

    set TEMP_INSTALL=!DEST:~0,-%CAPPATH_LEN%!\temp_cap
    @echo TEMP_INSTALL: %TEMP_INSTALL%

    set INST_DRIVE=!DEST:~0,2!

)

if !ERRORLEVEL! NEQ 0 (
    rem Create an error only if an existing registry query failed
    if !ERRORLEVEL! NEQ 1 (
        set INSTALL_ERROR=!ERROR_REGISTRY!
        goto err_common
    )
)
rem --------------------------------------

:end_reg_check

REM INSTALLATION PROCEDURE
if %CAP%=="" (
    @echo create path vars
    set INST_DRIVE=c:
    rem Other install location
    rem set INST_DRIVE=%HOMEDRIVE%%HOMEPATH%\Desktop
    set TEMP_INSTALL=!INST_DRIVE!\temp_cap
    set DEST=!INST_DRIVE!\cap
    set DEST_NAME=cap
)

REM ~ @echo %INST_DRIVE%
REM ~ @echo %TEMP_INSTALL%
REM ~ @echo %DEST%
REM ~ pause

set LNK=cap.lnk
set INSTALLTYPE=""

:check_args
set SELECT_MODE=0
set DEBUG_INSTALL=0
set SILNET_START=0
set AUTOSTART=0
set KEEP_SYS_CFG=0
set KEEP_CFG=0
set KEEP_DATA=0
set ANALYSEMODE=0
set DELAY_EXEC=0
set IGNORE_MQID=0
set UPDATE_FPGA=3
set INITIAL_INSTALL=0
set INSTALL_SCRIPT_SOURCES=0

set DEBUG_VERSION=Unknown
if exist debug_version.txt (
    for /F "usebackq tokens=*" %%a in (`type debug_version.txt`) do (
        call set DEBUG_VERSION=%%a
    )
)

set RELEASE_VERSION=Unknown
if exist debug_version.txt (
    for /F "usebackq tokens=*" %%a in (`type release_version.txt`) do (
        call set RELEASE_VERSION=%%a
    )
)

for %%f in (%*) do (

    if /i %%f == /engineering (
	    set INSTALL_SCRIPT_SOURCES=1
		set SELECT_MODE=1
    ) else if /i %%f == /debug (
        set DEBUG_INSTALL=1
		set SELECT_MODE=1
    ) else if /i %%f == /silentstart (
        set SILNET_START=1
    ) else if /i %%f == /autostart (
        set AUTOSTART=1
    ) else if /i %%f == /keepcfg (
        set KEEP_CFG=1
    ) else if /i %%f == /keepsyscfg (
        set KEEP_SYS_CFG=1
    ) else if /i %%f == /keepdata (
        set KEEP_DATA=1
    ) else if /i %%f == /skipcfg (
        set KEEP_CFG=2
    ) else if /i %%f == /skipsyscfg (
        set KEEP_SYS_CFG=2
    ) else if /i %%f == /skipdata (
        set KEEP_DATA=2
    ) else if /i %%f == /nohw (
        set ANALYSEMODE=1
    ) else if /i %%f == /hw (
        set ANALYSEMODE=2
    ) else if /i %%f == /delay (
        set DELAY_EXEC=1
    ) else if /i %%f == /ignoremqid (
        set IGNORE_MQID=1
    ) else if /i %%f == /updatefpga (
        set UPDATE_FPGA=1
    ) else if /i %%f == /skipupdatefpga (
        set UPDATE_FPGA=0
    ) else if /i %%f == /initial (
        reg add "HKCU\SOFTWARE\Miltenyi Biotec\CAPInstallWatcher" /v State /d 1 /t REG_DWORD /f
        set INITIAL_INSTALL=1
        set SILNET_START=1
        set DEBUG_INSTALL=0
        set KEEP_CFG=2
        set KEEP_SYS_CFG=2
        set KEEP_DATA=2
        set ANALYSEMODE=2
        set IGNORE_MQID=1
        set UPDATE_FPGA=0
        set DELAY_EXEC=0
    )
)

rem display arguments
if not (!DEBUG_INSTALL!)==() set DEBUG_INSTALL
if not (!SILNET_START!)==() set SILNET_START
if not (!AUTOSTART!)==() set AUTOSTART
if not (!KEEP_CFG!)==() set KEEP_CFG
if not (!KEEP_SYS_CFG!)==() set KEEP_SYS_CFG
if not (!KEEP_DATA!)==() set KEEP_DATA
if not (!ANALYSEMODE!)==() set ANALYSEMODE

rem --------------------------------------
rem wait for sec (RUN_SEC) to be sure
rem the caller (maybe cap) has been terminated!
rem (except os)
rem --------------------------------------#

rem this two processes must be terminated

taskkill -f -im kbd.exe
taskkill -f -im ctfmon.exe

if !DELAY_EXEC!==1 (
    SET RUN_MSSEC=20000
    wait !RUN_MSSEC! showcountdowninfo "!SOFTNAME! installer !INSTVER! [%%d sec to start, please wait ...]"
)

if not exist !DEST! goto install
:check_destination_begin
rename "%DEST%" "!DEST_NAME!_temp"

!CLS!
echo !SOFTNAME! installer !INSTVER!
echo.
echo.
echo.
if !SILNET_START!==0 (

    if !ERRORLEVEL! EQU 0 goto check_destination_done
    echo Please close the MACSQuantify Software ...
    echo.
    set CHOICE=
    set /p CHOICE="Continue? [ (Y)es /(A)bort ]: "

    if /i "!CHOICE!" =="A" (
        set UPDATE_FPGA=0
        goto check_for_restart_cap
    )

    goto check_destination_begin

) else (
    if !ERRORLEVEL! NEQ 0 (
        !CLS!
        set INSTALL_ERROR=!ERROR_OLD_CAP_ACCESS!
        goto err_oldcap
    )
)
:check_destination_done
if exist !DEST!_temp (
    rename "!DEST!_temp" "!DEST_NAME!"

    if !ERRORLEVEL! NEQ 0 (
        set INSTALL_ERROR=!ERROR_OLD_INSTALL_CAP_ACCESS!
        goto err_common
    )
)

:install
!CLS!
echo !SOFTNAME! installer !INSTVER!
echo.
echo.
echo.

if exist "!TEMP_INSTALL!" (
    echo Preparing installation ...
    rmdir /S /Q "%TEMP_INSTALL%"
    if exist "%TEMP_INSTALL%" (
        rem no errorlevel exist if rmdir failed! ->
        rem we do it manually, of course this is a fake to provoke an error
        echo "X" | find "Y" 1> nul 2> nul

        echo Preparing installation failed ...
        goto err_common
    )
    if !ERRORLEVEL! NEQ 0 (
        set INSTALL_ERROR=!ERROR_INSTALL_PREPARE_CAP!
        goto err_common
    )
    !CLS!
    echo !SOFTNAME! installer !INSTVER!
    echo.
    echo.
    echo.
)

if !SILNET_START!==1 (
    if !DEBUG_INSTALL!==1 (
        goto main_debug
    ) else if !INSTALL_SCRIPT_SOURCES!==1 (
        goto :main_developer
    ) else (
        goto main_release
    )
)
echo Installation in !INST_DRIVE! ...
echo.
set CHOICE=
if !SELECT_MODE!==1 (
    set /p CHOICE="Which new cap-package do you want to install? [ (R)elease /(D)ebug / (E)ngineering /(A)bort ]: "
    goto check_install
)

rem ############################## iwa ##############################
rem set /p CHOICE="Do you want to install a new cap-package? [ (Y)es /(A)bort ]: "
set CHOICE=Y
rem ############################## iwa ##############################

:check_install

if /i "!CHOICE!" =="A" (
    set UPDATE_FPGA=0
    goto check_for_restart_cap
)

if !SELECT_MODE!==1 (
    if /i "!CHOICE!"=="E" goto main_developer
    if /i "!CHOICE!"=="R" goto main_release
    if /i "!CHOICE!"=="D" goto main_debug
    goto install
)
if /i "!CHOICE!"=="Y" goto main_release

goto install

:main_debug
rem set some usefull variables
set SRC=cap_d
set SRCHW=caphw_d
set INSTALLTYPE=debug
set CAP_VERSION=!DEBUG_VERSION!
set DEBUG_INSTALL=1
!CLS!
echo !SOFTNAME! installer !INSTVER!
echo Installing %INSTALLTYPE% version %CAP_VERSION% ...
goto make_install_choice

:main_release
rem set some usefull variables
set SRC=cap_r
set SRCHW=caphw_r
set INSTALLTYPE=release
set CAP_VERSION=!RELEASE_VERSION!
!CLS!
echo !SOFTNAME! installer !INSTVER!
echo Installing %INSTALLTYPE% version %CAP_VERSION% ...
goto make_install_choice

:main_developer
rem install debug and release files
set SRC=cap_r cap_d
set SRCHW=caphw_r caphw_d
set INSTALLTYPE=developer
set CAP_VERSION=!RELEASE_VERSION!
set INSTALL_SCRIPT_SOURCES=1
!CLS!
echo !SOFTNAME! installer !INSTVER!
echo Installing %INSTALLTYPE% version %CAP_VERSION% ...
goto make_install_choice

:make_install_choice
echo.

if !ANALYSEMODE!==1 (
    set UPDATE_FPGA=0
    REM ~ set LNK=capOnPC.lnk
    goto start
)
if !ANALYSEMODE!==2 (
    REM ~ set LNK=cap.lnk
    goto start
)

set CHOICE=
rem ############################## iwa ##############################
rem set /p CHOICE="Install on MacsQuant? [ [Y]es /[N]o /(A)bort ]: "
set CHOICE=N
rem ############################## iwa ##############################

if /i "!CHOICE!"=="A" (
    set UPDATE_FPGA=0
    goto check_for_restart_cap
)

if /i "!CHOICE!" =="N" (
    REM ~ set LNK=capOnPC.lnk
    set ANALYSEMODE=1
    set UPDATE_FPGA=0
    goto start
)
if /i "!CHOICE!" =="Y" (
    REM ~ set LNK=cap.lnk
    set ANALYSEMODE=2

    set CHOICE=
    set /p CHOICE="Upgrade acquisition driver? [ [Y]es /[N]o /(A)bort ]: "

    if /i "!CHOICE!"=="A" (
        set UPDATE_FPGA=0
        goto check_for_restart_cap
    )

    if /i "!CHOICE!"=="Y" (
        set UPDATE_FPGA=1
        goto start
    )
    if /i "!CHOICE!"=="N" (
        set UPDATE_FPGA=0
        goto start
    )
)

goto make_install_choice


:start


rem fpga driver update
if not !UPDATE_FPGA!==0 (

    taskkill /im Executer.exe /f

    dostools\devcon.exe remove *10F8*
    wait 5000 showinfo "Updating the fpga driver ..."

    rem rename the old miltenyi driver ...
    if not exist "%windir%\system32\drivers\_miltenyi3.sys.1.2.0922.R" (
        rename "%windir%\system32\drivers\miltenyi3.sys" "_miltenyi3.sys.1.2.0922.R"
        if !ERRORLEVEL! NEQ 0 (
            executer.exe
            set INSTALL_ERROR=!ERROR_SYSTEM_UPDATE!
            set UPDATE_FPGA=0
            goto err_common
        )
    )

    copy /Y /V system\fpga\miltenyi3.sys %windir%\system32\drivers\
    if !ERRORLEVEL! NEQ 0 (
        executer.exe
        set INSTALL_ERROR=!ERROR_SYSTEM_UPDATE!
        set UPDATE_FPGA=0
        goto err_common
    )

    copy /Y /V system\fpga\miltenyi.hex %windir%\
    if !ERRORLEVEL! NEQ 0 (
        executer.exe
        set INSTALL_ERROR=!ERROR_SYSTEM_UPDATE!
        set UPDATE_FPGA=0
        goto err_common
    )
	set REQUIRE_COMMIT=1
)
	
rem --------------------------------------------------------------------------------------------
rem -- Update executer if the install package contains a newer version
rem --------------------------------------------------------------------------------------------
if !ANALYSEMODE! == 2 (
	for /f %%i in ("c:\windows\system32\executer.exe") do set installed_executer_date=%%~ti
	for /f %%i in ("system\executer\executer.exe") do set package_executer_date=%%~ti
	
	if !installed_executer_date! NEQ !package_executer_date! (
    		taskkill /im Executer.exe /f
		for %%f in (executer.exe msvcm80.dll msvcp80.dll msvcp100.dll msvcr71.dll msvcr80.dll msvcr100.dll) do (
			xcopy /d /v /y /i system\executer\%%f c:\windows\system32
			if !ERRORLEVEL! NEQ 0 (
				executer.exe
				set INSTALL_ERROR=!ERROR_SYSTEM_UPDATE!
				goto err_common
			)
		)
		set REQUIRE_COMMIT=1
	)
)

rem --------------------------------------------------------------------------------------------
rem -- Deleting TSharc COM3,COM4 registry entries.

if !ANALYSEMODE! == 2 (
   for %%n in (3 4) do (
   
       reg query "HKLM\SYSTEM\ControlSet001\Services\tsharcs\Parameters" /v TSHARCS%%n 1> nul 2> nul
       if !ERRORLEVEL! EQU 0 (
           reg delete "HKLM\SYSTEM\ControlSet001\Services\tsharcs\Parameters" /v TSHARCS%%n /f 1> nul 2> nul
           set REQUIRE_COMMIT=1
       )
   
       reg query "HKLM\SYSTEM\ControlSet002\Services\tsharcs\Parameters" /v TSHARCS%%n 1> nul 2> nul
       if !ERRORLEVEL! EQU 0 (
           reg delete "HKLM\SYSTEM\ControlSet002\Services\tsharcs\Parameters" /v TSHARCS%%n /f 1> nul 2> nul
           set REQUIRE_COMMIT=1
       )
   )
   
   rem ensure COM1 and COM2 TSharc registry entries are present
   for %%n in (1 2) do (
      reg query "HKLM\SYSTEM\ControlSet001\Services\tsharcs\Parameters" /v TSHARCS%%n 1> nul 2> nul
      if !ERRORLEVEL! NEQ 0 (
         reg add "HKLM\SYSTEM\ControlSet001\Services\tsharcs\Parameters" /v TSHARCS%%n /d "\DosDevices\COM%%n" 1> nul 2> nul
         set REQUIRE_COMMIT=1
      )
   
      reg query "HKLM\SYSTEM\ControlSet002\Services\tsharcs\Parameters" /v TSHARCS%%n 1> nul 2> nul
      if !ERRORLEVEL! NEQ 0 (
         reg add "HKLM\SYSTEM\ControlSet002\Services\tsharcs\Parameters" /v TSHARCS%%n /d "\DosDevices\COM%%n" 1> nul 2> nul
         set REQUIRE_COMMIT=1
      )
   )

)
rem ----------------------------------------------------------------------------------------------


rem make installable for old windows xp embedded distributions
rem where the tools below have not been installed
if exist %windir%\system32\xcopy.exe goto check_to_keep_cfg
copy /V /B /Y dostools\xcopy.exe %windir%\system32
if !ERRORLEVEL! NEQ 0 (
    set INSTALL_ERROR=!ERROR_SYSTEM_PREPARE!
    goto err_common
)
if exist %windir%\system32\attrib.exe goto check_to_keep_cfg
copy /V /B /Y dostools\attrib.exe %windir%\system32
if !ERRORLEVEL! NEQ 0 (
    set INSTALL_ERROR=!ERROR_SYSTEM_PREPARE!
    goto err_common
)

:check_to_keep_cfg
if not exist !DEST! (
    set KEEP_CFG=0
    set KEEP_SYS_CFG=0
    set KEEP_DATA=0

    goto baseinstall
)

if !KEEP_CFG! GTR 0 goto check_to_keep_sys_cfg

!CLS!
echo !SOFTNAME! installer !INSTVER!
echo Installing %INSTALLTYPE% version %CAP_VERSION% ...
echo.

echo Do you want to keep all user settings ...
set CHOICE=
set /p CHOICE=(analyse templates, instrument settings, experiments, reagents)? [ (Y)es /(N)o /(A)bort ]:
if /i "!CHOICE!"=="A" (
    set UPDATE_FPGA=0
    goto check_for_restart_cap
)

if /i "!CHOICE!" =="N" goto check_to_keep_sys_cfg

if /i "!CHOICE!" =="Y" (
    set KEEP_CFG=1
    goto check_to_keep_sys_cfg
)

goto check_to_keep_cfg

:check_to_keep_sys_cfg
if !KEEP_SYS_CFG! GTR 0 goto check_to_keep_data

!CLS!
echo !SOFTNAME! installer !INSTVER!
echo Installing %INSTALLTYPE% version %CAP_VERSION% ...
echo.

set CHOICE=
set /p CHOICE="Do you want to keep the system configuration? [ (Y)es/(N)o /(A)bort ]: "

if /i "!CHOICE!"=="A" (
    set UPDATE_FPGA=0
    goto check_for_restart_cap
)

if /i "!CHOICE!" =="N" goto check_to_keep_data

if /i "!CHOICE!" =="Y" (
    set KEEP_SYS_CFG=1
    goto check_to_keep_data
)
goto check_to_keep_sys_cfg

:check_to_keep_data
if !KEEP_DATA! GTR 0 goto baseinstall

!CLS!
echo !SOFTNAME! installer !INSTVER!
echo Installing %INSTALLTYPE% version %CAP_VERSION% ...
echo.

set CHOICE=
set /p CHOICE="Do you want to keep all data files? [ (Y)es/(N)o /(A)bort ]: "

if /i "!CHOICE!"=="A" (
    set UPDATE_FPGA=0
    goto check_for_restart_cap
)

if /i "!CHOICE!" =="N" goto baseinstall

if /i "!CHOICE!" =="Y" (
    set KEEP_DATA=1
    goto baseinstall
)
goto check_to_keep_data

:baseinstall


rem just extract the package into a temp directory
if !ANALYSEMODE! == 2 (
    for %%p in ( %SRCHW% ) do extract /E %%p.cab /Y /L "%TEMP_INSTALL%"
)
for %%p in (%SRC%) do extract /E %%p.cab /Y /L "%TEMP_INSTALL%"

if !ERRORLEVEL! NEQ 0 (
    set INSTALL_ERROR=!ERROR_INSTALL_EXTRACT_CAP!
    goto err_common
)
rem make a copy of the mq.id
if not exist "!TEMP_INSTALL!\Lib\pys" (
    mkdir "!TEMP_INSTALL!\Lib\pys"

    if !ERRORLEVEL! NEQ 0 (
        set INSTALL_ERROR=!ERROR_CREATE_CAP!
        goto err_common
    )
)

if !IGNORE_MQID!==0 (
    rem make a copy of the mq.id
    if exist !DEST!\cfg\mq.id (
        echo keep id ...
        copy /V /B /Y "%DEST%\cfg\mq.id" "%TEMP_INSTALL%\cfg\mq.id"
        if !ERRORLEVEL! NEQ 0 (
            set INSTALL_ERROR=!ERROR_COPY_MQID!
            goto err_common
        )
    )
)

SET CFGVIEWER=%TEMP_INSTALL%\bin\CfgViewer.exe

if %DEBUG_INSTALL% NEQ 0 (
   SET CFGVIEWER=%TEMP_INSTALL%\bin\CfgViewer_d.exe
)

rem keep all system configs and settings
if !KEEP_SYS_CFG!==1 (
    rem check if any file exits
    dir %DEST%\cfg\*.cfg 1> nul 2> nul
    if !ERRORLEVEL! NEQ 0 (
        rem reset error level
        echo configurations not available...
        echo "X" | find "X" 1> nul 2> nul
    ) else (
        echo keeping configurations ...
        copy /V /B /Y "%DEST%\cfg\*.cfg" "%TEMP_INSTALL%\cfg"
        if !ERRORLEVEL! NEQ 0 (
            set INSTALL_ERROR=!ERROR_COPY_CFG_FROM_CFG!
            goto err_common
        )
        rem name of default configuration file was changed from defaults.cfg to default.cfg
        if exist "%DEST%\cfg\defaults.cfg" (
            rename "%TEMP_INSTALL%\cfg\defaults.cfg" "default.cfg"
            if !ERRORLEVEL! NEQ 0 (
                set INSTALL_ERROR=!ERROR_COPY_CFG_FROM_CFG!
                goto err_common
            )
        )
    )

    
    if exist "%TEMP_INSTALL%"\cfg\hardware.cfg (
      del "%TEMP_INSTALL%"\cfg\hardware.cfg
    )

    if exist "%TEMP_INSTALL%"\cfg\hardware.cfg.bak (
      del "%TEMP_INSTALL%"\cfg\hardware.cfg.bak
    )
	
	if exist %DEST%\cfg\Default.cfg (
		SET DEFAULTVERSION=0.0.0
	    rem Rename old Default.cfg to Options.cfg such that it can be converted to new Options.cfg	
		for /f "usebackq" %%X in (`%CFGVIEWER% --get Default\ConfigVersion %DEST%\cfg\Default.cfg`) do (SET DEFAULTVERSION=%%X)

		if !DEFAULTVERSION! leq 0.4.25 (
		
		    %CFGVIEWER% --set "FileType" --value "Options" "%TEMP_INSTALL%\cfg\Default.cfg"
		
            rename "%TEMP_INSTALL%\cfg\Default.cfg" "options.cfg"
            if !ERRORLEVEL! NEQ 0 (
                set INSTALL_ERROR=!ERROR_COPY_CFG_FROM_CFG!
                goto err_common
            )		
		) else (
			rem Delete Default.cfg such that it is recreated with updated settings
			del %DEST%\cfg\Default.cfg
		)
		
		if exist "%TEMP_INSTALL%"\cfg\Default.cfg.bak (
			del "%TEMP_INSTALL%"\cfg\Default.cfg.bak
		)

	)
)

rem Get user path from config
SET USERPATH=user
SET GLOBALPATH=global
SET EXPERIMENTSPATH=experiments
SET DEVICEPATH=device
SET ANALYSESPATH=analyses
SET WORKSPACEPATH=prj
SET DATAPATH=data

if exist %DEST%\cfg (
   for /f "usebackq" %%X in (`%CFGVIEWER% --get User\All\admin\UserDirs\Private %DEST%\cfg\user.cfg`) do (SET USERPATH=%%X)
   for /f "usebackq" %%X in (`%CFGVIEWER% --get User\GlobalDir %DEST%\cfg\user.cfg`) do (SET GLOBALPATH=%%X)
   for /f "usebackq" %%X in (`%CFGVIEWER% --get User\Experiments %DEST%\cfg\user.cfg`) do (SET EXPERIMENTSPATH=%%X)
   for /f "usebackq" %%X in (`%CFGVIEWER% --get User\Device %DEST%\cfg\user.cfg`) do (SET DEVICEPATH=%%X)
   for /f "usebackq" %%X in (`%CFGVIEWER% --get User\Analysis %DEST%\cfg\user.cfg`) do (SET ANALYSESPATH=%%X)
   for /f "usebackq" %%X in (`%CFGVIEWER% --get User\Workspaces %DEST%\cfg\user.cfg`) do (SET WORKSPACEPATH=%%X)
   for /f "usebackq" %%X in (`%CFGVIEWER% --get User\Data %DEST%\cfg\user.cfg`) do (SET DATAPATH=%%X)
)

echo Ensure global and user directories exist
if not exist %TEMP_INSTALL%\%GLOBALPATH% (mkdir %TEMP_INSTALL%\%GLOBALPATH%)
if not exist %TEMP_INSTALL%\%USERPATH% (mkdir %TEMP_INSTALL%\%USERPATH%)

rem update service analysis template and experiment files ("Produktionsrack")
set CONFIGURATIONS=FL7 FL8 VYB
for %%c in (%CONFIGURATIONS%) do (
   SET SERVICE_EXPERIMENTS_REMOVE=1_Befuellen-Puffer_%c%.cfg 2_Befuellen_Zellen-Beads_%c%.cfg 2a_Befuellen_Zellen-Beads_%c%.cfg 2b_Befuellen_Zellen-Beads_%c%.cfg 3_Messen_%c%.cfg
   SET SERVICE_EXPERIMENTS_INSTALL=1_Befuellen-Puffer_%c%.cfg 2a_Befuellen_Zellen-Beads_%c%.cfg 2b_Befuellen_Zellen-Beads_%c%.cfg 3_Messen_%c%.cfg
   SET SERVICE_TEMPLATES=Carryover_Prod_%c%.cfg Rainbow_Prod_%c%.cfg

   for %%e in (%SERVICE_EXPERIMENTS_REMOVE%) do (
      if exist "%TEMP_INSTALL%"\%USERPATH%\service\%EXPERIMENTSPATH%\%e% (
         del "%TEMP_INSTALL%"\%USERPATH%\service\%EXPERIMENTSPATH%\%e%
         if !ERRORLEVEL! NEQ 0 (
            set INSTALL_ERROR=!ERROR_DELETE_FILE!
            goto err_common
         )
      )
   )
   
   for %%e in (%SERVICE_EXPERIMENTS_INSTALL%) do (
      for %%p in (%SRCHW%) do extract /Y "%%p.cab" %e% /L "%TEMP_INSTALL%"

      if !ERRORLEVEL! NEQ 0 (
          set INSTALL_ERROR=!ERROR_INSTALL_EXTRACT_CAP!
          goto err_common
      )
   )

   for %%a in (%SERVICE_TEMPLATES%) do (
      if exist "%TEMP_INSTALL%"\%USERPATH%\service\%ANALYSESPATH%\%a% (
         del "%TEMP_INSTALL%"\%USERPATH%\service\%ANALYSESPATH%\%a%
         if !ERRORLEVEL! NEQ 0 (
            set INSTALL_ERROR=!ERROR_DELETE_FILE!
            goto err_common
         )
      )

      for %%p in (%SRCHW%) do extract /Y "%%p.cab" %a% /L "%TEMP_INSTALL%"
      if !ERRORLEVEL! NEQ 0 (
          set INSTALL_ERROR=!ERROR_INSTALL_EXTRACT_CAP!
          goto err_common
      )
   )
)

if "%USERPATH%" NEQ "user" (
   xcopy /I /S /Y "%TEMP_INSTALL%\user\service" "%TEMP_INSTALL%\%USERPATH%\service"
   rmdir /S /Q "%TEMP_INSTALL%\user"
)

rem keep all configs and settings
if !KEEP_CFG!==1 (

    rem check for existing user.cfg as a part of configs

    if exist "%DEST%\cfg\user.cfg" (
        echo keeping configurations ...
        copy /V /B /Y "%DEST%\cfg\user.cfg" "%TEMP_INSTALL%\cfg"
        if !ERRORLEVEL! NEQ 0 (
            set INSTALL_ERROR=!ERROR_COPY_USERCFG!
            goto err_common
        )
    )

    rem take all global settings
    dir /s %DEST%\%GLOBALPATH%\*.cfg 1> nul 2> nul
    if !ERRORLEVEL! NEQ 0 (
        rem reset error level
        echo global settings not availabe...
        echo "X" | find "X" 1> nul 2> nul
    ) else (
        echo keep global settings  ...
        xcopy /I /S /Y "%DEST%\%GLOBALPATH%\*.cfg" "%TEMP_INSTALL%\%GLOBALPATH%"
        if !ERRORLEVEL! NEQ 0 (
            set INSTALL_ERROR=!ERROR_COPY_CFG_FROM_GLOBAL!
            goto err_common
        )
    )

    rem take all of users
    dir /s %DEST%\%USERPATH%\*.cfg 1> nul 2> nul
    if !ERRORLEVEL! NEQ 0 (
        rem reset error level
        echo user settings not availabe...
        echo "X" | find "X" 1> nul 2> nul
    ) else (
        echo keeping user settings ...

        xcopy /I /S /Y "%DEST%\%USERPATH%\*.cfg" "%TEMP_INSTALL%\%USERPATH%"
        if !ERRORLEVEL! NEQ 0 (
            set INSTALL_ERROR=!ERROR_COPY_CFG_FROM_USER!
            goto err_common
        )
    )

    rem take all global backup registrations
    dir /s %DEST%\%GLOBALPATH%\*.rg 1> nul 2> nul
    if !ERRORLEVEL! NEQ 0 (
        rem reset error level
        echo global backup registration not availabe...
        echo "X" | find "X" 1> nul 2> nul
    ) else (
        echo keep global backup registration files ...
        xcopy /I /S /Y "%DEST%\%GLOBALPATH%\*.rg" "%TEMP_INSTALL%\%GLOBALPATH%"
        if !ERRORLEVEL! NEQ 0 (
            set INSTALL_ERROR=!ERROR_COPY_RG_FROM_GLOBAL!
            goto err_common
        )
    )

    rem take all user backup registrations
    dir /s %DEST%\%USERPATH%\*.rg 1> nul 2> nul
    if !ERRORLEVEL! NEQ 0 (
        rem reset error level
        echo user backup registrations not availabe...
        echo "X" | find "X" 1> nul 2> nul
    ) else (
        echo keeping user backup registration files ...
        xcopy /I /S /Y "%DEST%\%USERPATH%\*.rg" "%TEMP_INSTALL%\%USERPATH%"
        if !ERRORLEVEL! NEQ 0 (
            set INSTALL_ERROR=!ERROR_COPY_RG_FROM_USER!
            goto err_common
        )
    )

    if exist "%TEMP_INSTALL%"\%USERPATH%\service\%EXPERIMENTSPATH%\Befuellen-Puffer__1.cfg (
      del "%TEMP_INSTALL%"\%USERPATH%\service\%EXPERIMENTSPATH%\Befuellen-Puffer__1.cfg
    )
    if exist "%TEMP_INSTALL%"\%USERPATH%\service\%EXPERIMENTSPATH%\Befuellen_Zellen-Beads__2.cfg (
      del "%TEMP_INSTALL%"\%USERPATH%\service\%EXPERIMENTSPATH%\Befuellen_Zellen-Beads__2.cfg
    )
    if exist "%TEMP_INSTALL%"\%USERPATH%\service\%EXPERIMENTSPATH%\Messen__3.cfg (
      del "%TEMP_INSTALL%"\%USERPATH%\service\%EXPERIMENTSPATH%\Messen__3.cfg
    )

    for %%p in (%SRCHW%) do extract /Y "%%p.cab" Befuellen-Puffer__1a.cfg /L "%TEMP_INSTALL%"


    if !ERRORLEVEL! NEQ 0 (
        set INSTALL_ERROR=!ERROR_INSTALL_EXTRACT_CAP!
        goto err_common
    )

    REM ~ extract /Y "%SRCHW%.cab" Produktionsrack-Reagents.cfg /L "%TEMP_INSTALL%"

    REM ~ if !ERRORLEVEL! NEQ 0 (
        REM ~ set INSTALL_ERROR=!ERROR_INSTALL_EXTRACT_CAP!
        REM ~ goto err_common
    REM ~ )

    REM ~ another possibility extract all cfgs at once ...
    REM ~ extract /Y %SRCHW%.cab *.cfg /L %DEST%
    REM ~ if !ERRORLEVEL! NEQ 0 (
        REM ~ set INSTALL_ERROR=!ERROR_INSTALL_EXTRACT_CAP!
        REM ~ goto err_common
    REM ~ )

)
rem keep all data files
if !KEEP_DATA!==1 (
    rem take all global data
    dir /s %DEST%\%GLOBALPATH%\*.mqd 1> nul 2> nul
    if !ERRORLEVEL! NEQ 0 (
        rem reset error level
        echo global data not availabe...
        echo "X" | find "X" 1> nul 2> nul
    ) else (
        echo keeping global data files ...
        xcopy /I /S /Y "%DEST%\%GLOBALPATH%\*.mqd" "%TEMP_INSTALL%\%GLOBALPATH%"
        if !ERRORLEVEL! NEQ 0 (
            set INSTALL_ERROR=!ERROR_COPY_MQD_FROM_GLOBAL!
            goto err_common
        )
    )
    rem take all user data
    dir /s %DEST%\%USERPATH%\*.mqd 1> nul 2> nul
    if !ERRORLEVEL! NEQ 0 (
        rem reset error level
        echo user data not availabe...
        echo "X" | find "X" 1> nul 2> nul
    ) else (
        echo keeping user data files ...
        xcopy /I /S /Y "%DEST%\%USERPATH%\*.mqd" "%TEMP_INSTALL%\%USERPATH%"
        if !ERRORLEVEL! NEQ 0 (
            set INSTALL_ERROR=!ERROR_COPY_MQD_FROM_USER!
            goto err_common
        )
    )

    rem keep all global fcs-data
    dir /s %DEST%\%GLOBALPATH%\*.fcs 1> nul 2> nul
    if !ERRORLEVEL! NEQ 0 (
        rem reset error level
        echo global fcs-file not availabe...
        echo "X" | find "X" 1> nul 2> nul
    ) else (
        echo keeping global fcs-files ...
        xcopy /I /S /Y "%DEST%\%GLOBALPATH%\*.fcs" "%TEMP_INSTALL%\%GLOBALPATH%"
        if !ERRORLEVEL! NEQ 0 (
            set INSTALL_ERROR=!ERROR_COPY_FCS_FROM_GLOBAL!
            goto err_common
        )
    )

    rem keep all user fcs-data
    dir /s %DEST%\%USERPATH%\*.fcs 1> nul 2> nul
    if !ERRORLEVEL! NEQ 0 (
        rem reset error level
        echo user fcs-file not availabe...
        echo "X" | find "X" 1> nul 2> nul
    ) else (
        echo keeping user data fcs-files ...
        xcopy /I /S /Y "%DEST%\%USERPATH%\*.fcs" "%TEMP_INSTALL%\%USERPATH%"
        if !ERRORLEVEL! NEQ 0 (
            set INSTALL_ERROR=!ERROR_COPY_FCS_FROM_USER!
            goto err_common
        )
    )

    rem keep all global csv-data
    dir /s %DEST%\%GLOBALPATH%\*.csv 1> nul 2> nul
    if !ERRORLEVEL! NEQ 0 (
        rem reset error level
        echo global csv-file not availabe...
        echo "X" | find "X" 1> nul 2> nul
    ) else (
        echo keeping global csv-files ...
        xcopy /I /S /Y "%DEST%\%GLOBALPATH%\*.csv" "%TEMP_INSTALL%\%GLOBALPATH%"
        if !ERRORLEVEL! NEQ 0 (
            set INSTALL_ERROR=!ERROR_COPY_CSV_FROM_GLOBAL!
            goto err_common
        )
    )

    rem keep all user csv-data
    dir /s %DEST%\%USERPATH%\*.csv 1> nul 2> nul
    if !ERRORLEVEL! NEQ 0 (
        rem reset error level
        echo user csv-file not availabe...
        echo "X" | find "X" 1> nul 2> nul
    ) else (
        echo keeping user data csv-files ...
        xcopy /I /S /Y "%DEST%\%USERPATH%\*.csv" "%TEMP_INSTALL%\%USERPATH%"
        if !ERRORLEVEL! NEQ 0 (
            set INSTALL_ERROR=!ERROR_COPY_CSV_FROM_USER!
            goto err_common
        )
    )
)

rem delete very old packages

if !DISABLE_CLEANUP!==0 (
    if exist !DEST!.bak (
        echo cleanup last backup...
        rmdir /S /Q %DEST%.bak

        if exist !DEST!.bak (
            rem no errorlevel exist if rmdir failed! ->
            rem we do it manually, of course this is a fake to provoke an error
            echo "X" | find "Y" 1> nul 2> nul
            echo clean failed ...
            set INSTALL_ERROR=!ERROR_CLEANUP_BAK!
            goto err_oldcap
        )

        if !ERRORLEVEL! NEQ 0 (
            echo clean failed ...
            set INSTALL_ERROR=!ERROR_CLEANUP_BAK!
            goto err_oldcap
        )
        echo cleanup done ...
    )
)
rem make a backup from currently used software package
if exist !DEST! (
    echo backup old cap ...
    set SUFFIX=bak
    if !DISABLE_CLEANUP!==1 (

        for /F "usebackq tokens=*" %%a in (`type "%DEST%\bin\release_version.txt"`) do (
            call set SUFFIX=%%a
        )
        if exist "!DEST!.!SUFFIX!" (

            SET /A EXT_SUFFIX=1
            :loop3
            if exist "!DEST!.!SUFFIX!_!EXT_SUFFIX!" (
                SET /A EXT_SUFFIX+=1
                goto loop3
            )
            set SUFFIX=!SUFFIX!_!EXT_SUFFIX!
        )
    )

    echo rename "%DEST%" "!DEST_NAME!.!SUFFIX!"
    rename "%DEST%" "!DEST_NAME!.!SUFFIX!"

    if !ERRORLEVEL! NEQ 0 (
        echo backup failed ...
        set INSTALL_ERROR=!ERROR_CREATE_BACKUP!
        goto err_oldcap
    )

    echo backup done ...
)

rem make from temp-package an active package
if exist "!TEMP_INSTALL!" (
    rename "%TEMP_INSTALL%" "!DEST_NAME!"
    if !ERRORLEVEL! NEQ 0 (

        set INSTALL_ERROR=!ERROR_CREATE_CAP!
        goto err_common
    )
)

set CHOICE=
rem check for mq.id, if not exists make one ...
goto makelnk
REM ~ if exist %DEST%\cfg\mq.id goto makelnk
REM ~ !CLS!
REM ~ echo !SOFTNAME! installer !INSTVER!
REM ~ echo Installing %INSTALLTYPE% version ...
REM ~ if %INSTALLTYPE%=="debug" call %DEBUG_VERSION%
REM ~ if %INSTALLTYPE%=="release" call %RELEASE_VERSION%
REM ~ echo.

REM ~ set /p CHOICE="Please enter the MacsQuant serial number:"
REM ~ echo !CHOICE!>%DEST%\cfg\mq.id
REM ~ pause

:makelnk
rem make icons on the desktop and start menues
rem set USERHOME=%HOMEDRIVE%%HOMEPATH%
REM ~ set USERHOME=%ALLUSERSPROFILE%
REM ~ copy /V /B /Y %DEST%\bin\%LNK% "%USERHOME%"\Desktop
REM ~ if !ERRORLEVEL! NEQ 0 goto err_common
REM ~ dir /AD /B "%USERHOME%"\start*en* >> %TEMP%\StartDirs
REM ~ if !ERRORLEVEL! NEQ 0 goto err_common

REM ~ (for /F "tokens=1* delims=" %%A in (%TEMP%\StartDirs) DO (
    REM ~ echo copy into %%A

    REM ~ echo %DEST%\bin\%LNK%
    REM ~ echo "%USERHOME%"\"%%A"

    REM ~ copy /V /B /Y %DEST%\bin\%LNK% "%USERHOME%"\"%%A"
    REM ~ if !ERRORLEVEL! NEQ 0 (
       REM ~ goto err_common
    REM ~ )
REM ~ ))

rem for analysis only
if !ANALYSEMODE!==1 (
    SET CAP_ARGS=-s -l -n -I s
)
if !ANALYSEMODE!==2 (
    SET CAP_ARGS=-s -l -f -V

    REM ~ if not !UPDATE_FPGA!==0 (
        REM ~ SET CAP_ARGS=-s -l -f -V -I s
    REM ~ )
    REM ~ if !UPDATE_FPGA!==0 (
        REM ~ SET CAP_ARGS=-s -l -f -u -I s
    REM ~ )
)

rem debug install requires -z to use source instead of zlib
if !DEBUG_INSTALL!==1 (
    set CAP_ARGS=!CAP_ARGS! -z -r
    set INST_PATH=!DEST!\bin\cap_d.exe
    REM ~ if not exist "!DEST!\lib\pys" (
        REM ~ mkdir "!DEST!\lib\pys"
        REM ~ if !ERRORLEVEL! NEQ 0 (
            REM ~ set INSTALL_ERROR=!ERROR_CREATE_CAP!
            REM ~ goto err_common
        REM ~ )
    REM ~ )
) else if !INSTALL_SCRIPT_SOURCES!==1 (
    set CAP_ARGS=!CAP_ARGS! -z -r -D validation=5,process=5 -O validation=cmdl,process=cmdl
	set INST_PATH=!DEST!\bin\cap.exe
) else (
    set INST_PATH=!DEST!\bin\cap.exe
)

rem ############################################################################################################
rem I think some more error handling is needed here. (Ako, 2009KW09)
set USERHOME=%HOMEDRIVE%%HOMEPATH%
set ALLUSERHOME=%ALLUSERSPROFILE%

rem ############################## iwa ##############################
rem shortcut !INST_PATH!;!CAP_ARGS!;MACSQuantify;MACSQuant analysis software;25;!DEST!\cfg\mqlogo.ico;0
call mkshortcut /t:!INST_PATH! /a:"!CAP_ARGS!" /w:!DEST!\bin /s:1 /d:"MACSQuant analysis software" /i:!DEST!\cfg\mqlogo.ico,0 %USERPROFILE%\Desktop\MACSQuantify.lnk
rem ############################## iwa ##############################

if !ERRORLEVEL! NEQ 0 (
    shortcut !INST_PATH!;!CAP_ARGS!;MACSQuantify;MACSQuant analysis software;0;!DEST!\cfg\mqlogo.ico;0
    if !ERRORLEVEL! NEQ 0 (
        set INSTALL_ERROR=!ERROR_CREATE_LNK!
        goto err_common
    )

    move /Y "!USERHOME!\Desktop\MACSQuantify.lnk" "!ALLUSERHOME!\Desktop"
)

set CACLS_FAILED=0
cacls "!ALLUSERHOME!\DESKTOP\MACSQuantify.lnk" /C /T /E /G Benutzer:F

if !ERRORLEVEL! NEQ 0 (
    cacls "!ALLUSERHOME!\DESKTOP\MACSQuantify.lnk" /C /T /E /G Users:F
)
if !ERRORLEVEL! NEQ 0 (
    set CACLS_FAILED=1
)

rem ############################################################################################################
for /f "usebackq tokens=2*" %%i in (`reg query "HKCU\Software\Miltenyi Biotec\CAP" /v Parameter`) do set REG_CAP_ARGS=%%j
for /f "usebackq tokens=2*" %%i in (`reg query "HKCU\Software\Miltenyi Biotec\CAP" /v Image`) do set REG_CAP_IMAGE=%%j
for /F %%f in ( "%INST_PATH%" ) do set CAP_IMAGE=%%~nxf

if "%REG_CAP_ARGS%" NEQ "%CAP_ARGS%" (
	echo Setting cap arguments ...
	reg add "HKCU\Software\Miltenyi Biotec\CAP" /v Parameter /t REG_SZ /d "!CAP_ARGS!" /f 1> nul 2> nul
        set REQUIRE_COMMIT=1
)


if "%REG_CAP_IMAGE%" NEQ "%CAP_IMAGE%" (
	echo Setting cap image ...
        reg add "HKCU\Software\Miltenyi Biotec\CAP" /v Image /t REG_SZ /d "%CAP_IMAGE%" /f 1> nul 2> nul
        set REQUIRE_COMMIT=1
)

if exist "%TEMP%\StartDirs" (
    del /Q /S "%TEMP%\StartDirs" 1> nul 2> nul
    if !ERRORLEVEL! NEQ 0 (
        set INSTALL_ERROR=!ERROR_CLEANUP_TEMP!
        goto err_common
    )
)

cacls "%DEST%" /C /T /E /G Benutzer:F
if !ERRORLEVEL! NEQ 0 (
    cacls "%DEST%" /C /T /E /G Users:F
)

if !ERRORLEVEL! NEQ 0 (
    if !ANALYSEMODE!==2 (
        set INSTALL_ERROR=!ERROR_SET_ACCESS_RIGHTS!
        goto err_common
    )
    set CACLS_FAILED=1
)

rem in case of hardware installation without keeping system settings we have to remove the hardware-profile file
if !ANALYSEMODE! EQU 2 (
   del /q /f %DEST%\lib\profiles\hardware.py
)

:fin_make
!CLS!
echo !SOFTNAME! installer !INSTVER!
echo Installation of %CAP_VERSION% finished successfully.
echo.
if !CACLS_FAILED!==1 (
echo.
echo Please set the access and write permissions for all users manually.
echo.
)
:check_for_restart_cap
if !AUTOSTART!==1 (
    goto start_cap
)
goto finish
:start_cap
echo Starting cap application.
if %REG_CAP%==0 (
    !INST_DRIVE!
    cd !DEST!\bin
    @"!ALLUSERHOME!\DESKTOP\MACSQuantify.lnk"
)
goto finish2

:err_oldcap
rem !CLS!
echo !SOFTNAME! installer !INSTVER!
echo Installation of !SOFTNAME! version %CAP_VERSION% failed!
echo.
echo Failed to backup the old cap directory.
echo To fix this problem, remove or rename
echo manually the cap directory and try again.
echo ErrorLevel: !INSTALL_ERROR!
pause
goto check_for_restart_cap

:err_common
rem !CLS!
echo !SOFTNAME! installer !INSTVER!
echo Installation of !SOFTNAME! version %CAP_VERSION% failed!
echo.
echo Could not finish the cap installation, bacause an error occurred.
echo Please call your service provider or report it under http:\\www.miltenyibiotec.de to clarify this issue.
echo ErrorLevel: !INSTALL_ERROR!
pause
goto check_for_restart_cap

:finish
if !INITIAL_INSTALL!==0 (
    if !SILNET_START!==0 (
        pause
    )
)

:finish2

if %REG_CAP%==1 (
reg add "HKCU\Software\Miltenyi Biotec\CAP" /v State /t REG_DWORD /d 0 /f 1> nul 2> nul)

rem if fpga update should be performed then we need the commit to the cf...
if not !UPDATE_FPGA!==0 (
    set REQUIRE_COMMIT=1
)

rem if initial installation has been done then we need the commit to the cf...
if !INITIAL_INSTALL!==1 (

    reg add "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon" /v shell /d "executer.exe Miltenyi Biotec\CAP" /t REG_SZ /f
    ewfmgr.exe c: -enable
    set REQUIRE_COMMIT=1
)

if !REQUIRE_COMMIT! EQU 1 (
    if !ANALYSEMODE! EQU 2 (
    	if !INSTALL_ERROR!==!ERROR_NONE! (
        	echo The MacsQuant must be restarted to make the changes take effect.

        	if !SILNET_START!==0 (
           	 pause
        	)

       		ewfmgr.exe c: -commit
        	shutdown /f /s /t 10 /c "The MACSQuant is shutting down to make the changes take effect. Please, reboot the system again."
        	exit
   	 ) 
    )
)
:finish3
echo ErrorLevel: !INSTALL_ERROR!

exit
